"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Box;
var _react = _interopRequireDefault(require("react"));
var _propTypes = require("./props/propTypes");
var _defaultProps = require("./props/defaultProps");
var _utils = require("./utils");
var _LayoutModule = _interopRequireDefault(require("./Layout.module.css"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable  react/no-unused-prop-types*/

function getBoxClassNames(props) {
  var hidden = props.hidden,
    className = props.className,
    flexible = props.flexible,
    adjust = props.adjust,
    isFirst = props.isFirst,
    isLast = props.isLast,
    shrink = props.shrink,
    column = props.column,
    align = props.align,
    scroll = props.scroll,
    preventParentScroll = props.preventParentScroll;
  var modificators = [className];
  if (flexible && !adjust) {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'grow'));
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'basis'));
  } else if (flexible && adjust) {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'grow'));
  }
  if (isFirst) {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'first'));
  }
  if (isLast) {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'last'));
  }
  if (adjust) {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'basisAuto'));
  }
  if (shrink) {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'shrinkOn'));
  } else {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], 'shrinkOff'));
  }
  if (hidden) {
    hidden.forEach(function (key) {
      modificators.push((0, _utils.getClass)(_LayoutModule["default"], "hidden-screen-".concat(key)));
    });
  }
  if (column) {
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], "col-".concat(column)));
  }
  if (align) {
    var alignClassMapping = {
      start: 'selfStart',
      end: 'selfEnd',
      center: 'selfCenter'
    };
    var alignClass = alignClassMapping[align];
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], alignClass));
  }
  if (scroll) {
    var scrollClassMapping = {
      horizontal: 'scrollx',
      vertical: 'scrolly',
      both: 'scrollboth',
      none: 'scrollnone'
    };
    var scrollClass = scrollClassMapping[scroll];
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], scrollClass));
  }
  if (preventParentScroll) {
    var ParentScrollClassMapping = {
      horizontal: 'preventScrollBubbleX',
      vertical: 'preventScrollBubbleY',
      both: 'preventScrollBubbleBoth'
    };
    var parentScrollClass = ParentScrollClassMapping[preventParentScroll];
    modificators.push((0, _utils.getClass)(_LayoutModule["default"], parentScrollClass));
  }
  return modificators;
}
function getBoxProps(props) {
  return (0, _utils.createProps)(_propTypes.BoxProps, props, getBoxClassNames(props));
}
function Box(props) {
  var tagName = props.tagName;
  var componentProps = (0, _utils.setProps)(_objectSpread({}, getBoxProps(props)), props, {
    isScrollAttribute: 'data-scroll',
    eleRef: 'ref',
    dataId: 'data-id',
    testId: 'data-test-id',
    tourId: 'data-tour',
    dataSelectorId: 'data-selector-id'
  });
  return /*#__PURE__*/_react["default"].createElement(tagName, componentProps);
}
Box.propTypes = _propTypes.BoxProps;
Box.defaultProps = _defaultProps.BoxDefaultProps;