"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Heading;
var _react = _interopRequireDefault(require("react"));
var _defaultProps = require("./props/defaultProps");
var _propTypes = require("./props/propTypes");
var _HeadingModule = _interopRequireDefault(require("../../Heading/Heading.module.css"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function Heading(props) {
  var tagName = props.tagName,
    className = props.className,
    onClick = props.onClick,
    onDoubleClick = props.onDoubleClick,
    title = props.title,
    dataTitle = props.dataTitle,
    dataId = props.dataId,
    a11y = props.a11y;
  return /*#__PURE__*/_react["default"].createElement(tagName, _objectSpread({
    className: "".concat(_HeadingModule["default"].reset, " ").concat(className),
    onClick: onClick,
    onDoubleClick: onDoubleClick,
    'data-title': dataTitle || title,
    'data-id': dataId,
    'data-test-id': dataId
  }, a11y), title);
}
Heading.propTypes = _propTypes.propTypes;
Heading.defaultProps = _defaultProps.defaultProps;

// if (__DOCS__) {
//   Heading.docs = {
//     folderName: 'Style Guide',
//     componentGroup: 'Accessibility'
//   };
// }